const electron = require("electron");
const app = electron.app;
const BrowserWindow = electron.BrowserWindow;
const Menu = electron.Menu;
const dialog = electron.dialog;
var ps = require('ps-node');






const path = require("path");
const fs = require("fs");
const psList = require('ps-list');
const fetch = require('node-fetch');


let mainWindow;
let initPath;


function createAddWindow() {
  addWindow = new BrowserWindow({
    width: 1024,
    height: 768,
    title: 'TSB Search'
  });
  addWindow.loadURL('https://www.google.com')
}

let menuTemplate = [
    {
        label: "Window Manager",
        submenu: [
          {
            label: 'Quit',
            accelerator: process.platform === 'darwin' ? 'Command+Q' : 'Ctrl+Q',
            click() {
              app.quit();
            }
          }
        ]
    },
    {
      label : "TSB",
            submenu : [
              {
                label: 'Search' ,
                click() { createAddWindow(); }
              },
        ]
    }
];

app.allowRendererProcessReuse = true;
app.on("ready", () => {
  initPath = path.join(app.getPath("userData"), "init.json");

  try {
    data = JSON.parse(fs.readFileSync(initPath, "utf8"));
  } catch (e) { }

  mainWindow = new BrowserWindow({
    width: 1024,
    height: 768,
    icon: path.join(__dirname, "assets/icons/png/64x64.png"),
    //titleBarStyle: 'hidden',
    //frame: false,
    backgroundColor: "#b8d877",
    webPreferences: {
      nodeIntegration: true,
      webviewTag: true,
      zoomFactor: 1.0,
      enableRemoteModule: true,
      frame: false,
    },
  });
  
  
  
  mainWindow.loadURL('https://www.knsinstitute.com/s2324SWrs0suiernidfhi49HREEUbfei3.php')
  // let menu = Menu.buildFromTemplate(menuTemplate);
  // Menu.setApplicationMenu(menu);
  var appspids = new Set();
  var appsrunning = new Set();
  var checkApps = 1;
  // task list check.
  function checkProcess() {
    
    (async () => {
        var plists = await psList()
        let url = "http://www.knsinstitute.com/json.php";
        let settings = { method: "Get" };
    
        fetch(url, settings).then(res => res.json()).then((json) => {
            for (var index = 0; index < plists.length; ++index) {
                var foundIt = valueExists(json, plists[index].cmd);
                if (foundIt != null) {
                    // console.log(plists[index]);
                    // if(appsrunning.indexOf(foundIt))
                    // continue;

                      appspids.add(plists[index].pid);
                      appsrunning.add(foundIt);
                    
                    // mainWindow.loadURL("https://www.knsinstitute.com/notAllowed.php?rec=" + foundIt);
                    // break;
                }
            }
        });
        if(appspids.size > 0 && checkApps == 1){
          console.log(appspids)
          console.log(appsrunning)
          let message="";
          
          for (item of appsrunning.values())
          message += item.toUpperCase() + '\n  ';

          checkApps = false
          dialog.showMessageBox({
            title: 'Confirm',
              icon: 'alert.png',
              message: 'These apps you have to close first: \n'+message,
              buttons: ['Yes', 'No'],
              defaultId: 0, // bound to buttons array
              cancelId: 1 // bound to buttons array
            })
            .then(result => {
              if (result.response === 0) {
                for (ids of appspids.values())
                {
                  ps.kill(ids, function( err ) {
                    if (err) {
                        throw new Error( err );
                    }
                    else {
                        console.log( 'Process with pid '+ids+' has been killed!');
                    }
                });
                
                }
                checkApps = 1;
              } else if (result.response === 1) {
                checkApps = false;
                mainWindow.loadURL("https://www.knsinstitute.com/notAllowed.php?rec=" + message);
              }
            }
          );
        }
        
    })
    
    ();    
}



setInterval(function(){
  checkProcess()
}, 5000)

function valueExists(jsObj, value) {
  for (var index = 0; index < jsObj.length; ++index) {
      var myWord = jsObj[index].toLowerCase().replace(".exe", "");

      var myPattern = new RegExp('(\\w*' + myWord + '\\w*)', 'gi');
      var matches = value.toLowerCase().match(myPattern);

      if (matches != null) {
          return myWord;
      }
  }
  return null;
}

  function getJSON(url, callback) {

    var xhr = new XMLHttpRequest();
    xhr.open('GET', url, true);
    xhr.responseType = 'json';
    
    xhr.onload = function() {
    
        var status = xhr.status;
        
        if (status == 200) {
            callback(null, xhr.response);
        } else {
            callback(status);
        }
    };
    
    xhr.send();
};




});

// Quit when all windows are closed.
app.on("window-all-closed", () => {
  data = {
    bounds: mainWindow.getBounds(),
  };
  fs.writeFileSync(initPath, JSON.stringify(data));
  app.quit();
});
